<!--
 * @Descripttion: (表情包分类/tb_emotion_category 编辑弹窗)
 * @version: (1.0)
 * @Author: (lwh)
 * @Date: (2023-10-28)
 * @LastEditors: (lwh)
 * @LastEditTime: (2023-10-28)
-->
<template>
  <el-dialog v-model="props.modelValue" title="修改表情包分类信息" width="900px" @closed="closeDialog" @open="openDialog">
    <el-form ref="formRef" :model="formData" :rules="rules">
      <el-row :gutter="20">

        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="上级菜单" prop="EmotionCategoryParentGuid">
            <el-cascader class="w100" :options="dataList"
              :props="{ checkStrictly: true, value: 'emotionCategoryGuid', label: 'emotionCategoryName', emitPath: false }"
              placeholder="请选择上级菜单" clearable v-model="formData.emotionCategoryParentGuid">
              <template #default="{ node, data }">
                <span>{{ data.emotionCategoryName }}</span>
                <span v-if="!node.isLeaf"> ({{ data.children.length }}) </span>
              </template>
            </el-cascader>
          </el-form-item>
        </el-col>


        <el-col :lg="12">
          <el-form-item :label-width="labelWidth" label="名称" prop="emotionCategoryName">
            <el-input v-model="formData.emotionCategoryName" placeholder="请输入名称" />
          </el-form-item>
        </el-col>
        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="图片" prop="emotionCategoryImg">
            <UploadImage ref="uploadRef" v-model="formData.emotionCategoryImg" :data=imgData :limit="1" :fileSize="5"
              :drag="true" />
          </el-form-item>
        </el-col>
        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="是否为热门" prop="isPopular">
            <el-radio-group v-model="formData.isPopular">
              <el-radio v-for="item in  is_popular " :key="item.dictValue" :label="parseInt(item.dictValue)">{{
                item.dictLabel }}</el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>
        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="浏览次数" prop="emotionCategoryViewsNum">
            <el-input-number v-model.number="formData.emotionCategoryViewsNum" controls-position="right" :min="0" />
          </el-form-item>
        </el-col>
        <el-col :lg="12">
          <el-form-item :label-width="labelWidth" label="排序" prop="emotionCategorySort">
            <el-input-number v-model.number="formData.emotionCategorySort" controls-position="right" :min="0" />
          </el-form-item>
        </el-col>

      </el-row>
    </el-form>

    <template #footer>
      <div class="dialog-footer">
        <el-button type="primary" @click="handleEditClick(formRef)" :loading="loadingStatus">编辑</el-button>
        <el-button @click="handleResetClick(formRef)">重置</el-button>
      </div>
    </template>
  </el-dialog>
</template>

<script setup>
import { ElMessage } from 'element-plus'
import modal from '@/plugins/modal.js'
import { reactive, ref, watch } from "vue";
import { emotionCategoryTreeList, addOrUpdateEmotionCategory } from "@/api/business/EmotionManage/EmotionCategorys/emotionCategory.js";


// 打开弹窗时回调
const openDialog = async () => {
  await getis_popular()

  await getTreeList()
}

const formData = ref({
  ...props.data,
});
watch(props, async (v) => {
  formData.value = v.data;

});

// 业务参数
const dataList = ref([])
// 是否为热门字典选项列表
const is_popular = ref([]);

// -业务方法
//字典获取
async function getis_popular() {
  await proxy.getDicts('is_popular').then((res) => {
    is_popular.value = res.data
  })
}



// -基础参数
const props = defineProps({
  modelValue: Boolean,
  data: Object,
  done: Function,
});

const loadingStatus = ref(false)
const labelWidth = 100;
const formRef = ref();
const { proxy } = getCurrentInstance()
const emits = defineEmits(["update:modelValue"]);
const imgData = ref({
  fileDir: "EmotionCategory"
})

// 验证
const rules = reactive({
  emotionCategoryName: [{ required: true, message: "名称不能为空", trigger: "blur" }],
  isPopular: [{ required: true, message: "是否为热门不能为空", trigger: "blur", type: "number" }],
  emotionCategoryViewsNum: [{ required: true, message: "浏览次数不能为空", trigger: "blur", type: "number" }],
  emotionCategorySort: [{ required: true, message: "排序不能为空", trigger: "blur", type: "number" }],
});

// -基础方法
async function getTreeList() {
  emotionCategoryTreeList().then((res) => {
    if (res.code == 200) {
      dataList.value = res.data
    }
  })
}
// 提交
const handleEditClick = async (formEl) => {
  if (!formEl) return;
  formEl.validate(async (valid) => {
    if (!valid) {
      return;
    }
    loadingStatus.value = true


    const { code } = await addOrUpdateEmotionCategory(formData.value);
    if (code == 200) {
      modal.msgSuccess('修改成功')
      closeDialog();
      loadingStatus.value = false
    }
    else{
      loadingStatus.value = false
    }
  });
}

const handleResetClick = async (formEl) => {
  if (!formEl) return;
  formEl.resetFields();
}
const closeDialog = () => {
  props.done();
  emits("update:modelValue", false);
};

</script>
